#rzr

pronounced _"razor"_, rzr is a highly-opinionated full-stack application framework written in coffeescript on node.js

rzr is designed to promote a deep philosophical understanding of the system and to allow the developer to focus solely on the application's core domain, implementing ideas from Domain Driven Design (DDD) and enforcing Behavior Driven Development (BDD)

---

### get started

install the rzr executable globally:

    $ npm install -g rzr
    
create an app:

    $ rzr create haiWorld

which will generate an application called `haiWorld` in your current directory

---

### application structure

    /appName
        
        /config             # configuration files
    
        /domain             # the *domain* is the unique part of your application - what the app "does"  
        
            /module         # *modules* are collections of related models, services and views                        
            
                /models     # entities, the "things" in your system with unique identities
                
                /services   # units of procedural code that get stuff done
                
                /ui         # User Interface (ui) widgets and layouts specific to the module

        /layout             # global layout templates and ui widgets

        /logs               # logs
        
        /plugins            # 3rd party plugins to application
        
        /rzr                # rzr-specific framework files

